%global momorel 2
%global realver 2.0.876
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Summary: iSCSI daemon and utility programs
Name: iscsi-initiator-utils
Version: 6.2.0.876
Release: %{momorel}m%{?dist}
#Source0: http://www.open-iscsi.org/bits/open-iscsi-%{realver}.tar.gz
Source0: https://github.com/open-iscsi/open-iscsi/archive/%{realver}/open-iscsi-%{realver}.tar.gz
NoSource: 0
Source4: 04-iscsi
Source5: iscsi-tmpfiles.conf

Patch0001: 0001-idmb_rec_write-check-for-tpgt-first.patch
Patch0002: 0002-idbm_rec_write-seperate-old-and-new-style-writes.patch
Patch0003: 0003-idbw_rec_write-pick-tpgt-from-existing-record.patch
Patch0004: 0004-update-systemd-service-files-add-iscsi.service-for-s.patch
Patch0005: 0005-iscsi-boot-related-service-file-updates.patch
Patch0006: 0006-update-initscripts-and-docs.patch
Patch0007: 0007-use-var-for-config.patch
Patch0008: 0008-use-red-hat-for-name.patch
Patch0009: 0009-libiscsi.patch
Patch0010: 0010-remove-the-offload-boot-supported-ifdef.patch
Patch0011: 0011-iscsiuio-systemd-unit-files.patch
Patch0012: 0012-disable-iscsid.startup-from-iscsiadm-prefer-systemd-.patch
Patch0013: 0013-Don-t-check-for-autostart-sessions-if-iscsi-is-not-u.patch
Patch0014: 0014-start-socket-listeners-on-iscsiadm-command.patch
Patch0015: 0015-Revert-iscsiadm-return-error-when-login-fails.patch
Patch0016: 0016-update-handling-of-boot-sessions.patch
Patch0017: 0017-update-iscsi.service-for-boot-session-recovery.patch
Patch0018: 0018-updates-to-iscsi.service.patch
Patch0019: 0019-make-session-shutdown-a-seperate-service.patch.patch
Patch0020: 0020-Add-macros-to-release-GIL-lock.patch
Patch0021: 0021-libiscsi-introduce-sessions-API.patch
Patch0022: 0022-use-Red-Hat-version-string-to-match-RPM-package-vers.patch
Patch0023: 0023-fix-discoverydb-command-timeout.patch
Patch0024: 0024-libiscsi-fix-discovery-timeout-regression.patch
Patch0025: 0025-libiscsi-format-security-build-errors.patch 

Group: System Environment/Daemons
License: GPLv2+
URL: http://www.open-iscsi.org
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: openssl-devel flex bison
BuildRequires: python >= 2.7
BuildRequires: isns-utils-devel
Requires(post): chkconfig
Requires(preun): chkconfig initscripts
Requires: initscripts
ExcludeArch: s390 s390x

%description
The iscsi package provides the server daemon for the iSCSI protocol,
as well as the utility programs used to manage it. iSCSI is a protocol
for distributed disk access using SCSI commands sent over Internet
Protocol networks.

%package iscsiuio
Summary: Userspace configuration daemon required for some iSCSI hardware
Group: System Environment/Daemons
License: BSD
Requires: %{name} = %{version}-%{release}

%description iscsiuio
The iscsiuio configuration daemon provides network configuration help
for some iSCSI offload hardware.

%package devel
Summary: Development files for %{name}
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%prep
%setup -q -n open-iscsi-%{realver}
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
#%%patch0006 -p1
#%%patch0007 -p1
%patch0008 -p1
#%%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
#%patch0012 -p1
%patch0013 -p1
#%%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
#%%patch0020 -p1
#%%patch0021 -p1
#%%patch0022 -p1
#%%patch0023 -p1
#%%patch0024 -p1
#%%patch0025 -p1

%build
cd iscsiuio
autoreconf --install
%{configure}
cd ..

%{__make} OPTFLAGS="%{optflags} %{?__global_ldflags} -DUSE_KMOD -lkmod"

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install

%{__install} -d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
%{__install} -pm 644 iscsiuio/iscsiuiolog $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d

%{__install} -d $RPM_BUILD_ROOT%{_var}/lib/iscsi
%{__install} -d $RPM_BUILD_ROOT%{_var}/lib/iscsi/nodes
%{__install} -d $RPM_BUILD_ROOT%{_var}/lib/iscsi/send_targets
%{__install} -d $RPM_BUILD_ROOT%{_var}/lib/iscsi/static
%{__install} -d $RPM_BUILD_ROOT%{_var}/lib/iscsi/isns
%{__install} -d $RPM_BUILD_ROOT%{_var}/lib/iscsi/slp
%{__install} -d $RPM_BUILD_ROOT%{_var}/lib/iscsi/ifaces

%{__install} -d $RPM_BUILD_ROOT/var/lock/iscsi
touch $RPM_BUILD_ROOT/var/lock/iscsi/lock

%{__install} -d $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsi.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsi-shutdown.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsid.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsid.socket $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsiuio.service $RPM_BUILD_ROOT%{_unitdir}
%{__install} -pm 644 etc/systemd/iscsiuio.socket $RPM_BUILD_ROOT%{_unitdir}

%{__install} -d $RPM_BUILD_ROOT%{_libexecdir}
%{__install} -pm 755 etc/systemd/iscsi-mark-root-nodes $RPM_BUILD_ROOT%{_libexecdir}

%{__install} -d $RPM_BUILD_ROOT%{_sysconfdir}/NetworkManager/dispatcher.d
%{__install} -pm 755 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/NetworkManager/dispatcher.d

%{__install} -d $RPM_BUILD_ROOT%{_tmpfilesdir}
%{__install} -pm 644 %{SOURCE5} $RPM_BUILD_ROOT%{_tmpfilesdir}/iscsi.conf

rm -rf  $RPM_BUILD_ROOT/%{_sysconfdir}/init.d

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%systemd_post iscsi.service iscsi-shutdown.service iscsid.service iscsid.socket

if [ $1 -eq 1 ]; then
        if [ ! -f %{_sysconfdir}/iscsi/initiatorname.iscsi ]; then
                echo "InitiatorName=`/usr/sbin/iscsi-iname`" > %{_sysconfdir}/iscsi/initiatorname.iscsi
        fi
        # enable socket activation and persistant session startup by default
        /bin/systemctl enable iscsi.service >/dev/null 2>&1 || :
        /bin/systemctl enable iscsid.socket >/dev/null 2>&1 || :
fi 

%preun
%systemd_preun iscsi.service iscsi-shutdown.service iscsid.service iscsid.socket 

%preun iscsiuio
%systemd_preun iscsiuio.service iscsiuio.socket

%postun
/sbin/ldconfig
%systemd_postun

%postun iscsiuio
%systemd_postun

%triggerun -- iscsi-initiator-utils < 6.2.0.873-25
# prior to 6.2.0.873-24 iscsi.service was missing a Wants=remote-fs-pre.target
# this forces remote-fs-pre.target active if needed for a clean shutdown/reboot
# after upgrading this package
if [ $1 -gt 0 ]; then
    /usr/bin/systemctl -q is-active iscsi.service
    if [ $? -eq 0 ]; then
        /usr/bin/systemctl -q is-active remote-fs-pre.target
        if [ $? -ne 0 ]; then
            SRC=`/usr/bin/systemctl show --property FragmentPath remote-fs-pre.target | cut -d= -f2`
            DST=/run/systemd/system/remote-fs-pre.target
            if [ $SRC != $DST ]; then
                cp $SRC $DST
            fi
            sed -i 's/RefuseManualStart=yes/RefuseManualStart=no/' $DST
            /usr/bin/systemctl daemon-reload >/dev/null 2>&1 || :
            /usr/bin/systemctl start remote-fs-pre.target >/dev/null 2>&1 || :
        fi
    fi
fi
# added in 6.2.0.873-25
if [ $1 -gt 0 ]; then
    systemctl start iscsi-shutdown.service >/dev/null 2>&1 || :
fi

%files
%defattr(-,root,root)
%doc README
%ghost %{_var}/lock/iscsi
%ghost %{_var}/lock/iscsi/lock
%dir %{_var}/lib/iscsi
%dir %{_var}/lib/iscsi/nodes
%dir %{_var}/lib/iscsi/isns
%dir %{_var}/lib/iscsi/static
%dir %{_var}/lib/iscsi/slp
%dir %{_var}/lib/iscsi/ifaces
%dir %{_var}/lib/iscsi/send_targets
%dir %{_var}/lock/iscsi
%{_unitdir}/iscsi.service
%{_unitdir}/iscsi-shutdown.service
%{_unitdir}/iscsid.service
%{_unitdir}/iscsid.socket
%{_unitdir}/iscsiuio.service
%{_unitdir}/iscsiuio.socket
%{_libexecdir}/iscsi-mark-root-nodes
%{_sysconfdir}/NetworkManager/dispatcher.d/04-iscsi
%dir %{_sysconfdir}/iscsi
%dir %{_sysconfdir}/iscsi/ifaces
%{_sysconfdir}/iscsi/ifaces/iface.example
%{_sysconfdir}/iscsi/initiatorname.iscsi
%{_tmpfilesdir}/iscsi.conf
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/iscsi/iscsid.conf
/sbin/iscsi-iname
/sbin/iscsiadm
/sbin/iscsid
/sbin/iscsi-gen-initiatorname
/sbin/iscsi_discovery
/sbin/iscsi_fw_login
/sbin/iscsi_offload
#%/sbin/iscsistart
%{_libdir}/libopeniscsiusr.so.*
#%%{_libdir}/libiscsi.so.0
#%%{python_sitearch}/libiscsimodule.so
%{_mandir}/man8/*

%files iscsiuio
/sbin/iscsiuio
%{_unitdir}/iscsiuio.service
%{_unitdir}/iscsiuio.socket
%config(noreplace) %{_sysconfdir}/logrotate.d/iscsiuiolog
%{_mandir}/man8/iscsiuio.8.*

%files devel
%defattr(-,root,root,-)
#%%doc libiscsi/html
%{_libdir}/libopeniscsiusr.so
%{_libdir}/pkgconfig/libopeniscsiusr.pc
#%%{_libdir}/libiscsi.so
#%{_includedir}/libiscsi.h
%{_includedir}/libopeniscsi*.h

%changelog
* Thu Mar 08 2018 Yohsuke Ooi <meke@momonga-linux.org>
- (6.2.0.876-2m)
- BR isns-utils-devel

* Tue Mar 06 2018 Yohsuke Ooi <meke@momonga-linux.org>
- (6.2.0.876-1m)
- update 6.2.9.876

* Fri Jun 13 2014 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (6.2.0.870.1-10m)
- Patch2: iscsi-initiator-utils-use-momonga-for-name.patch

* Fri Apr 29 2011 Yohsuke Ooi <meke@momonga-linux.org> 
- (6.2.0.870.1-9m)
- rebuild for python-2.7

* Mon Apr 11 2011 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (6.2.0.870.1-8m)
- rebuild for new GCC 4.6

* Sun Nov 28 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (6.2.0.870.1-7m)
- rebuild for new GCC 4.5

* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (6.2.0.870.1-6m)
- full rebuild for mo7 release

* Thu Feb 18 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (6.2.0.870.1-5m)
- apply glibc212 patch

* Sun Nov 15 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (6.2.0.870.1-4m)
- rebuild against gcc-4.4 and glibc-2.11

* Sun Jul 19 2009 Ryu SASAOKA <ryu@momonga-linux.org>
- (6.2.0.870.1-3m)
- stop daemon

* Sat Jun  6 2009 Ichiro Nakai <ichiro@n.email.ne.jp>
- (6.2.0.870.1-2m)
- release %%{_sysconfdir}/NetworkManager, it's provided by initscripts
- Requires: initscripts

* Sun Feb 22 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (6.2.0.870.1-1m)
- update 6.2.0.870.1
- split iscsi-initiator-utils-devel package

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (6.2.0.870-0.1.3m)
- rebuild against rpm-4.6

* Mon Oct  6 2008 Yohsuke Ooi <meke@momonga-linux.org> 
- (6.2.0.870-0.2m)
- stop auto-start

* Fri Jul  4 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (6.2.0.870-0.1m)
- update 2.0-870-rc1

* Tue Jun 24 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (6.2.0.868-2m)
- use %%{_initscriptdir} instead of %%{_initrddir}
- own %%{_sysconfdir}/iscsi
- modify Requires

* Tue Jun 24 2008 Masahiro Takahata <takahata@momonga-linux.org>
- (6.2.0.868-1m)
- sync Fedora

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (6.2.0.754-4m)
- rebuild against gcc43

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (6.2.0.754-3m)
- %%NoSource -> NoSource

* Wed Jun 20 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (6.2.0.754-2m)
- stop auto start

* Wed May  2 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (6.2.0.754-1m)
- update 6.2.0.754
- add iscsid daemon

* Wed Dec 13 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (6.2.0.695-1m)
- initial commit(import from FC-devel)



